# -*- coding: utf-8 -*-
from odoo.upgrade import util


def migrate(cr, version):
    util.remove_record(cr, "openerp_enterprise.email_template_mig_pricing2022")

    util.remove_field(cr, "sale.order", "new_sub_id")
    util.remove_field(cr, "sale.order", "enterprise_is_new_plan")
    util.remove_field(cr, "sale.order", "enterprise_has_latest_pricelist")
    util.remove_field(cr, "sale.order", "enterprise_is_online")
    util.remove_field(cr, "sale.order", "enterprise_is_new_enterprise")
    util.remove_field(cr, "sale.order", "state_subscription")

    util.remove_field(cr, "openerp.enterprise.domain.request", "message_main_attachment_id")
    util.remove_field(cr, "openerp.enterprise.domain", "message_main_attachment_id")

    util.remove_view(cr, "openerp_enterprise.maintenance_subscription_list")

    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code,
                              '("stage_category", "=", "progress")',
                              '("subscription_state", "in", ["3_progress", "4_paused"])')
         WHERE id = 4397
    """)
    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code,
                              'stage_category in (''progress'',''paused'')',
                              'subscription_state in (''3_progress'',''4_paused'')')
         WHERE id = 4876
    """)
    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code, 'email_from', 'partner_id.email')
         WHERE id = 1709
    """)
    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code,
                              '(''stage_category'', ''!='', ''draft'')',
                              '(''subscription_state'', ''not in'', [''1_draft'', ''2_renewal''])')
         WHERE id = 4911;
    """)
    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code,
                              '(''stage_category'', ''!='', ''closed'')',
                              '(''subscription_state'', ''not in'', [''5_renewed'', ''6_churn''])')
         WHERE id = 4899;
    """)
    cr.execute("""
        DELETE FROM ir_cron where id = 281
    """)
    cr.execute("""
        DELETE FROM ir_act_server where id = 4865
    """)
    cr.execute("""
        UPDATE mail_template
           SET email_to = ''
         WHERE model_id = 187
           AND email_to ilike '%{{ '''' if object.partner_id else object.email_from }}%'
    """)
    cr.execute("""
        UPDATE mail_template
           SET email_to = '{{ object.partner_id and object.partner_id.email }}'
         WHERE model_id = 187
           AND email_to ilike '%{{ object.email_from }}%';
    """)

    partner_bank_dedup = util.import_script("base/saas~15.2.1.3/pre-10-rm-duplicate-partner-banks.py")
    partner_bank_dedup.migrate(cr, version)

    # message_post_with_template has been change to message_post_with_source
    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code, 'message_post_with_template', 'message_post_with_source')
         WHERE code like '%message_post_with_template%'
    """)

    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code, 'INSURANCE_TEMPLATE_MAIL_ID', 'env[''mail.template''].browse(INSURANCE_TEMPLATE_MAIL_ID)')
         WHERE id = 5075
    """)

    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code, 'MAILS[typ]', 'env[''mail.template''].browse(MAILS[typ])')
         WHERE id = 4775
    """)

    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(code, '(''custo_tfr.email_template_presales_done'').id', '(''custo_tfr.email_template_presales_done'')')
         WHERE id = 3338
    """)

    cr.execute("""
        UPDATE ir_act_server
           SET code = REPLACE(
                REPLACE(code, '7418', 'env[''mail.template''].browse(MAILS[7418])'),
                'record[''kanban_state''] = ''blocked''', 'record[''state''] = ''02_changes_requested'''
            )
         WHERE id = 3724
    """)
